lappend auto_path .
package require nx 
package require STORM
################################
######Simple Example Stack######
################################

##class Stack with operations push, pop, top, size and full
## and attributes limit and element
nx::Class create Stack {
  :property -accessor public {limit:integer 4 }
  :property -accessor public {element {} }
  
  :public method size { } {
    return [llength [:element get]]    
  }
  :public method full { } {
    set full 0
    if { [:limit get] <= [:size] } {
      set full 1   
    }
    return $full        
  }
  :public method push {e} {
    if {[:full]} {
      return 0
    } else {
      :element set [concat [list $e] [:element get]]
      return 1
    }	    
  }	
  :public method pop { } {
    set top [:top]
      :element set [lrange [:element get] 1 end]
      return $top			
  }	
  :public method top { } {
    set top [lindex [:element get] 0]
    return $top				
  }
}

##scenario-test specification
#test case pushElement
set pe [::STORM::TestCase new -name PushElement]
$pe setup_script set {
  set s1 [::Stack new]
  $s1 push 3.5
  #$s1 push 4.3	
}
$pe preconditions set {
  {expr {[[::Stack info instances] size] == 1}}
}
#test scenario pushOnFullStack
set fs [::STORM::TestScenario new -name pushOnFullStack -testcase PushElement]
$fs expected_result set 0
$fs setup_script set {
  [::Stack info instances] limit set 1
}
$fs preconditions set {
  {expr {[[::Stack info instances] size] == 1}}
  {expr {[[::Stack info instances] limit get] == 1}}
}
$fs test_body set {
  [::Stack info instances] push 1.4 

}
$fs postconditions set {
  {expr {[[::Stack info instances] size] == 1}}
}

##run test in STORM	
set StackTests [::STORM::TestSuite new -detailed_report 1]
$StackTests order set [lsort -unique [::STORM::TestCase info instances]]
$StackTests runAllTestCases

##create with config model all call types and isEntireTestSuite
set vmc [::VM::VMCreator new]
$vmc createXMIModel view1 both "" "" "" true
